#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "astro.h"
#include "sofa.h"   // 2015/03/16 
#include "sofam.h"  // 2015/03/16

// Matrix_3 `

// Nutation_Precession_Matrix based on Astromical Almanac 2014 B52-B56 

void Nutation_Precession_Matrix (double jd,Matrix_3 *Pr,double dE0, double dF0)
{

	double t,B_gamma,B_phi,B_psi,psi,E;

	Matrix_3 Pr1,Pr2,Pr3,Pr4,Pr5,Pr6; // 2016/10/10

	t=(jd-2451545.0)/36525.0;
	B_gamma=   -0.052928 +   10.556378*t + 0.4932044*t*t -0.00031238*t*t*t -  2.788e-6*t*t*t*t + 2.60e-8*t*t*t*t*t;
	B_phi  =84381.412819 -   46.811016*t + 0.0512680*t*t +0.00053289*t*t*t -  0.440e-6*t*t*t*t - 1.76e-8*t*t*t*t*t;
	B_psi  =   -0.041775 + 5038.481484*t + 1.5584175*t*t -0.00018522*t*t*t - 26.452e-6*t*t*t*t - 1.48e-8*t*t*t*t*t;

	B_gamma=B_gamma/3600.0*pai;
	B_phi  =B_phi /3600.0*pai;
	B_psi  =B_psi /3600.0*pai;

	psi=B_psi+dF0;
    
	E=Obl_2000(jd);

	Matrix_R1(Pr1,   - E  , &Pr1);
	Matrix_R3(Pr2,  -psi  , &Pr2);
	Matrix_R1(Pr3, B_phi  , &Pr3);
	Matrix_R3(Pr4, B_gamma, &Pr4);

	Multi_Matrix_3(Pr1,Pr2,&Pr5);
	Multi_Matrix_3(Pr5,Pr3,&Pr6);
	Multi_Matrix_3(Pr6,Pr4,Pr);

}
